From bbc6cad700eb158515434d99aa73bad4fa29e8d0 Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: May 20 2020 15:05:57 +0000
Subject: [PATCH 2/3] patch to do cleanup and fix problems found during review


---

diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index e01a9ec..8c281c1 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -180,8 +180,7 @@ static CL5Desc s_cl5Desc = {0};
 
 /* changelog initialization and cleanup */
 static int _cl5Open(CL5OpenMode openMode);
-static int _cl5AppInit(void);
-static int _cl5DBOpen(void);
+static int _cldb_CheckAndSetEnv(Slapi_Backend *be);
 static void _cl5Close(void);
 static void _cl5DBClose(void);
 
@@ -1253,16 +1252,9 @@ cl5GetOperationCount(Replica *replica)
 static int
 _cl5Open(CL5OpenMode openMode)
 {
-    int rc;
+    int rc = CL5_SUCCESS;
 
     s_cl5Desc.dbOpenMode = openMode;
-    /* initialize db environment */
-    rc = _cl5AppInit();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Open - Failed to initialize db environment\n");
-        goto done;
-    }
 
     replica_enumerate_replicas(cldb_SetReplicaDB, NULL);
 	
@@ -1272,15 +1264,6 @@ _cl5Open(CL5OpenMode openMode)
         goto done;
     }
 
-    /* open database files */
-    rc = _cl5DBOpen();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Open - Failed to open changelog database\n");
-
-        goto done;
-    }
-
 done:;
 
     if (rc != CL5_SUCCESS) {
@@ -1343,6 +1326,7 @@ cldb_UnSetReplicaDB(Replica *replica, void *arg)
 int
 cldb_SetReplicaDB(Replica *replica, void *arg)
 {
+    int rc = -1;
     DB *pDB = NULL;
     cldb_Handle *cldb = NULL;
 
@@ -1359,7 +1343,8 @@ cldb_SetReplicaDB(Replica *replica, void *arg)
 
     Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
     Object *ruv_obj = replica_get_ruv(replica);
-    int rc = -1;
+
+    rc = _cldb_CheckAndSetEnv(be);
  
     rc = slapi_back_get_info(be, BACK_INFO_DBENV_CLDB, (void **)&pDB);
     if (rc == 0) {
@@ -1471,39 +1456,30 @@ cldb_StopThreads(Replica *replica, void *arg)
 }
 
 static int
-_cl5AppInit(void)
+_cldb_CheckAndSetEnv(Slapi_Backend *be)
 {
     int rc = -1; /* initialize to failure */
     DB_ENV *dbEnv = NULL;
-    char *cookie = NULL;
-    Slapi_Backend *be = slapi_get_first_backend(&cookie);
-    while (be) {
-        rc = slapi_back_get_info(be, BACK_INFO_DBENV, (void **)&dbEnv);
-        if ((LDAP_SUCCESS == rc) && dbEnv) {
-                    break; /* Successfully fetched */
-        }
-        be = slapi_get_next_backend(cookie);
+
+    if (s_cl5Desc.dbEnv) {
+        /* dbEnv already set */
+        return CL5_SUCCESS;
     }
-    slapi_ch_free((void **)&cookie);
+
+    rc = slapi_back_get_info(be, BACK_INFO_DBENV, (void **)&dbEnv);
 
     if (rc == 0 && dbEnv) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5AppInit - Fetched backend dbEnv (%p)\n", dbEnv);
+                      "_cldb_CheckAndSetEnv - Fetched backend dbEnv (%p)\n", dbEnv);
         s_cl5Desc.dbEnv = dbEnv;
         return CL5_SUCCESS;
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5AppInit - Failed to fetch backend dbenv\n");
+                      "_cldb_CheckAndSetEnv - Failed to fetch backend dbenv\n");
         return CL5_DB_ERROR;
     }
 }
 
-static int
-_cl5DBOpen()
-{
-    return CL5_SUCCESS;
-}
-
 /* this function assumes that the entry was validated
    using IsValidOperation
 

